#ifndef MAINFRM_H
#define MAINFRM_H

#include <QDialog>
#include "ui_mainfrm.h"

class QLabel;

class mainfrm : public QDialog
{
	Q_OBJECT

public:
	mainfrm(QWidget *parent = 0);
	~mainfrm();

protected:
	void keyPressEvent(QKeyEvent *k);

	Ui::mainfrm ui;

public slots:
	void nextlevel();
	void prevlevel();
	void restartlevel();
	void move_ennemis();
	void move_ennemis_3();
	void move_bateaux_1();
	void move_ennemis_4();
	void move_ennemis_5();

private:
	void charge_level();
	void ctrl_surprise();
	void ctrl_poissons();
	void ctrl_deplacement(int depx, int depy);
	void cassetout();
	void init();
	void vidage();

	QTimer *mytimer;
	QTimer *mytimer_2;
	QTimer *mytimer_3;
	QTimer *mytimer_4;
	QTimer *mytimer_5;
	QLabel *mylab;
	QLabel *pntlab;
	QLabel *pntdep;
	QLabel *pntpok;
	int posx;
	int posy;
	int herox;
	int heroy;
	int culevel;
	int indice0;
	int indice1;
	int indice2;
	int indice3;
	int indice4;
	int indice5;
	int indicex;
	int indicey;
	bool ok;
	QString tmp01;
	QString tmp02;
	QString tmp03;
	QString tmp04;
	QString progress;
	QString plateau[18][14];
	QLabel *table_cube[90];
	QLabel *table_cube_neige[50];
	QLabel *table_coeur[50];
	QLabel *table_hache[10];
	QLabel *table_bateau_1[5];
	QLabel *table_mur[150];
	QLabel *table_surprise[50];
	QLabel *table_bombe[20];
	QLabel *table_monstre_1[30];
	QLabel *table_monstre_2[30];
	QLabel *table_monstre_3[30];
	QLabel *table_monstre_4[30];
	QLabel *table_monstre_5[30];
	QLabel *table_glace[80];
	QLabel *table_autre[50];
	QLabel *table_eau[90];
	QLabel *table_cube_magique[30];
	int table_locmons_1[30][3];
	int table_locmons_2[30][3];
	int table_locmons_3[30][4];
	int table_locmons_4[30][4];
	int table_locmons_5[30][3];
	int table_locbato_1[5][4];
	QString table_locbato_2[5][2];
	int table_loccubm_1[50][2];
	int cpt_mur;
	int cpt_eau;
	int cpt_cube;
	int cpt_coeur;
	int cpt_autre;
	int cpt_glace;
	int cpt_bombe;
	int cpt_hache;
	int cpt_bateau_1;
	int cpt_surprise;
	int cpt_monstre_1;
	int cpt_monstre_2;
	int cpt_monstre_3;
	int cpt_monstre_4;
	int cpt_monstre_5;
	int cpt_cube_neige;
	int cpt_cube_magique;
	int max_coeur;
	int nbre_surprise_prise;
};

#endif
